if(isFile("Add-Ons/Sound_Blockland/server.cs"))
{
   forceRequiredAddOn("Sound_Blockland");
}
else
{
 datablock AudioProfile(Block_Admin_Sound)
{
	filename = "base/data/sound/admin.wav";
	description = AudioClosest3d;
	preload = false;
};


datablock AudioProfile(Block_Break_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/breakBrick.wav";
};
datablock AudioProfile(Block_Clear_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/brickClear.wav";
};
datablock AudioProfile(Block_ChangeBrick_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/clickChange.wav";
};
datablock AudioProfile(Block_MoveBrick_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/clickMove.wav";
};
datablock AudioProfile(Block_PlantBrick_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/clickPlant.wav";
};
datablock AudioProfile(Block_RotateBrick_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/clickRotate.wav";
};
datablock AudioProfile(Block_SMoveBrick_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/clickSuperMove.wav";
};
datablock AudioProfile(Block_Connect_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/playerConnect.wav";
};
datablock AudioProfile(Block_Leave_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/playerLeave.wav";
};
datablock AudioProfile(Block_Complete_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/processComplete.wav";
};
datablock AudioProfile(Block_LoadEnd_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/uploadEnd.wav";
};
datablock AudioProfile(Block_LoadStart_Sound : Block_Admin_Sound)
{
	filename = "base/data/sound/uploadStart.wav";
};
}

//sounds
datablock AudioProfile(superBoomstickFireSound)
{
   filename    = "./Sounds/Shotgun_B.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ExplosionData(superBoomstickRecoilExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
  camShakeFreq = "2 2 2";
  camShakeAmp = "0.6 0.6 0.6";
   camShakeDuration = 0.5;
   camShakeRadius = 5.0;

   lightstartradius = 2;
   lightEndRadius = 2;
   lightstartColor = "1.0 1.0 0.7";
   lightEndColor = "0 0 0";
};

datablock ProjectileData(superBoomstickRecoilProjectile)
{
	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= superBoomstickRecoilExplosion;

};

datablock ParticleData(superBoomstickSmokeParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.3;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 1;
	sizes[1]      = 2;

	useInvAlpha = true;
};
datablock ParticleEmitterData(superBoomstickSmokeEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 40;
   velocityVariance = 20.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 55;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "superBoomstickSmokeParticle";

   useEmitterColors = true;
};


datablock ParticleData(superBoomstickRingParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 60;
	lifetimeVarianceMS   = 0;
	textureName          = "./shapes/blastflash2";
	spinSpeed		= 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 5;
	sizes[1]      = 7;

	useInvAlpha = false;
};
datablock ParticleEmitterData(superBoomstickRingEmitter)
{
	//lifeTimeMS = 100;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 25;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "superBoomstickRingParticle";

   useEmitterColors = false;
};

datablock ParticleData(superBoomstickSparkParticle)
{
    dragCoefficient      = 4;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.5;
	constantAcceleration = 0.0;
	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 3.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.7 0.5 0.9";
	colors[1]     = "1 0.7 0.5 0.0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(superBoomstickSparkEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 60.0;
   velocityVariance = 50.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 40;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "superBoomstickSparkParticle";
};

datablock DebrisData(superBoomstickShellDebris)
{
	shapeFile = "./shapes/bushido's_shell_shotgun.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 5;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 3;
};

AddDamageType("superBoomstick",   '<bitmap:add-ons/Weapon_Gun/CI_gun> <bitmap:base/client/ui/ci/generic> %1',    '%2 <bitmap:add-ons/Weapon_Gun/CI_gun> <bitmap:base/client/ui/ci/generic> %1',0.75,1);

datablock ProjectileData(superBoomstickProjectile)
{
	projectileShapeName = "";

};

datablock ItemData(superBoomstickItem)
{
   category = "Weapon";  // Mission editor category
   className = "Weapon"; // For inventory system

    // Basic Item Properties
   shapeFile = "./shapes/weapons/db.dts";
   rotate = false;
   mass = 1;
   density = 0.2;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

   //gui stuff
   uiName = "Super Boomstick";
   iconName = "./shapes/superBoomstick";
   doColorShift = true;
   colorShiftColor = "0.5 0.5 0.5 1.000";

   maxmag = 2;
   ammotype = "Super Boomstick";
   reload = true;

   nochamber = 1;

    // Dynamic properties defined by the scripts
   image = superBoomstickImage;
   canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(superBoomstickImage)
{
   // Basic Item properties
   shapeFile = "./shapes/weapons/db.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = superBoomstickItem;
   ammo = " ";
   projectile = superBoomstickProjectile;
   projectileType = Projectile;

   casing = superBoomstickShellDebris;
   shellExitDir        = "1.0 0 4";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 15.0;   
   shellVelocity       = 6.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = superBoomstickItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Activate";
   stateTimeoutValue[0]             = 0.15;
   stateTransitionOnTimeout[0]      = "ammoCheck";
	stateSound[0]                    = weaponSwitchSound;

   stateName[1]                     = "Ready";
   stateTransitionOnTriggerDown[1]  = "Fire";
   stateTransitionOnNoAmmo[1]       = "Empty";
   stateAllowImageChange[1]         = true;
   stateSequence[1]                 = "root";

   stateName[2]                     = "Fire";
   stateTimeoutValue[2]             = 0.001;
   stateTransitionOnTimeout[2]      = "Smoke";
   stateFire[2]                     = true;
   stateAllowImageChange[2]         = false;
   stateScript[2]                   = "onFire";
   stateWaitForTimeout[2]           = true;
   stateEmitter[2]                  = superBoomstickSmokeEmitter;
   stateEmitterTime[2]              = 0.1;
   stateEmitterNode[2]              = "muzzlePoint";

   stateName[3]                     = "Smoke";
   stateTimeoutValue[3]             = 0.0001;
   stateEmitter[3]                  = superBoomsticksparkEmitter;
   stateEmitterTime[3]              = 0.05;
   stateTransitionOnTimeout[3]    = "SmokeB";
   stateScript[3]                   = "onSmoke";
   stateWaitForTimeout[3]           = true;
    
    stateName[13]                     = "SmokeB";
   stateTimeoutValue[13]             = 0.4;
   stateEmitter[13]                  = superBoomstickRingEmitter;
   stateEmitterTime[13]              = 0.1;
   stateTransitionOnTimeout[13]    = "Ready";
   //stateScript[13]                   = "onSmoke";
   stateWaitForTimeout[13]           = true;

   stateName[4]                     = "Cycle";
   stateTimeoutValue[4]             = 0.0001;
   stateScript[4]                   = "onCycle";
   stateSequence[4]                 = "Fire";
   stateEmitterNode[4]              = "muzzlePoint";
   stateEjectShell[4]               = true;
   stateSound[4]                    = shortRifleCycleSound;
   stateTransitionOnTimeout[4]      = "Ready";

   stateName[5]                     = "AmmoCheck";
   stateTransitionOnTimeout[5]      = "Ready";
   stateAllowImageChange[5]         = true;
   stateScript[5]                   = "onAmmoCheck";

   stateName[6]                     = "Reload";
   stateTransitionOnTimeout[6]      = "ReloadB";
   stateTimeoutValue[6]             = 0.2;
   stateSequence[6]		    = "reload";
    stateEjectShell[6]              = true;
    stateSound[6]                    = Block_PlantBrick_Sound;
   stateAllowImageChange[6]         = true;
   stateScript[6]                   = "onReloadStart";
    
    stateName[12]                     = "ReloadB";
   stateTransitionOnTimeout[12]      = "ReloadReady";
   stateTimeoutValue[12]             = 2;
   stateSequence[12]		    = "reload";
    stateEjectShell[12]              = true;
    stateSound[12]                    = Block_PlantBrick_Sound;
   stateAllowImageChange[12]         = true;
   //stateScript[12]                   = "onReloadStart";
  //stateSound[6]                    = "";

   stateName[7]                     = "ReloadReady";
   stateTransitionOnTimeout[7]      = "Ready";
   stateTimeoutValue[7]             = 0.1;
   stateAllowImageChange[7]         = true;
   stateScript[7]                   = "onReload";
   stateSequence[7]                 = "root";
stateSound[7]                   = Block_MoveBrick_Sound;

   stateName[8]                     = "Empty";
   stateTransitionOnTriggerDown[8]  = "EmptyFire";
   stateAllowImageChange[8]         = true;
   stateScript[8]                   = "onEmpty";
   stateTransitionOnAmmo[8]         = "Reload";
    stateSequence[8]                 = "root";
   //stateSequence[8]                 = "noammo";

   stateName[9]                     = "EmptyFire";
   stateTransitionOnTriggerUp[9]    = "Empty";
   stateTimeoutValue[9]             = 0.13;
   stateAllowImageChange[9]         = false;
   stateWaitForTimeout[9]           = true;
   //stateSound[9]                    = Block_clickPlant_Sound;
   stateSequence[9]                 = "root";

   stateName[10]                     = "Cycledown";
   stateTimeoutValue[10]             = 0.25;
   stateScript[10]                   = "onCycle";
   stateSequence[10]                 = "Fire";
   stateEmitterNode[10]              = "muzzlePoint";
   stateEjectShell[10]               = true;
  // stateSound[10]                    = shortRifleCycleSound;
   stateTransitionOnTimeout[10]      = "ammocheck";
   stateSound[10]                    = "";
};

  ////// ammo display functions
function superBoomstickImage::onMount( %this, %obj, %slot )
{parent::onMount(%this,%obj,%slot); hl2DisplayAmmo(%this,%obj,%slot,0);}

function superBoomstickImage::onUnMount( %this, %obj, %slot )
{parent::onUnMount(%this,%obj,%slot); hl2DisplayAmmo(%this,%obj,%slot,-1);}

function superBoomstickImage::onAmmoCheck( %this, %obj, %slot )
{hl2AmmoCheck(%this,%obj,%slot);
    //hack to force bots to reload
    if(%obj.getClassName() $= "AiPlayer")
    {
        %obj.schedule(2000,setImageAmmo,0,1);
    }
 hl2DisplayAmmo(%this,%obj,%slot);}

  /////// reload functions
function superBoomstickImage::onReloadStart( %this, %obj, %slot )
{
   %obj.playThread(2,shiftDown);
   serverPlay3d( shortRifleReloadOut3Sound, %obj.getHackPosition());

   //%obj.schedule(850, "playThread", "2", "shiftRight");
   %obj.schedule(1950, "playThread", "2", "rotcw");
   %obj.schedule(2150, "playThread", "2", "plant");

   //schedule(850, 0, serverPlay3D, shortRifleReloadTap2Sound, %obj.getHackPosition());
   schedule(1950, 0, serverPlay3D, Block_RotateBrick_Sound, %obj.getHackPosition());
   //schedule(2150, 0, serverPlay3D, shortRifleReloadTap0Sound, %obj.getHackPosition());

   hl2DisplayAmmo(%this,%obj,%slot);
}

function superBoomstickImage::onCycle( %this, %obj, %slot )
{
	%obj.playThread(2, shiftDown);
	%obj.playThread(0, shiftDown);
}

function superBoomstickImage::onReload( %this, %obj, %slot )
{
   hl2AmmoOnReload(%this,%obj,%slot); 
   hl2DisplayAmmo(%this,%obj,%slot);
}

function superBoomstickImage::onEmpty(%this,%obj,%slot)
{
   if( $hl2Weapons::Ammo && %obj.toolAmmo[%this.item.ammotype] < 1 )
   {
      return;
   }

   if(%obj.toolMag[%obj.currTool] < 1)
   {
      serverCmdLight(%obj.client);
   }
}

function superBoomstickImage::onSmoke( %this, %obj, %slot )
{
   hl2DisplayAmmo(%this,%obj,%slot);
}

function superBoomstickImage::onFire(%this,%obj,%slot)
{
   if(%obj.getDamagePercent() > 1.0)
   {
      return;
   }

   %obj.toolMag[%obj.currTool] -= 1;
    

   if(%obj.toolMag[%obj.currTool] < 1)
   {
      %obj.toolMag[%obj.currTool] = 0;
      %obj.setImageAmmo(0,0);
   }
    //hack to force bots to reload
    if(%obj.getClassname() $= "AiPlayer")
    {
        %obj.schedule(2000,setImageAmmo,0,1);
    }
   hl2DisplayAmmo(%this,%obj,%slot);

	%obj.spawnExplosion(superBoomstickRecoilProjectile,"1 1 1");
	
   serverPlay3d( superBoomstickFireSound, %obj.getHackPosition());
	if(%obj.getDamagePercent() >= 1.0)
		return;
	
	Parent::onFire(%this,%obj,%slot);

	%obj.playThread(2, plant);

	%fvec = %obj.getForwardVector();
  %fX = getWord(%fvec,0);
  %fY = getWord(%fvec,1);
  
  %evec = %obj.getEyeVector();
  %eX = getWord(%evec,0);
  %eY = getWord(%evec,1);
  %eZ = getWord(%evec,2);
  
  %eXY = mSqrt(%eX*%eX+%eY*%eY);
  
  %aimVec = 0 SPC 0 SPC %eZ;

	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%aimVec,"-7")));


	%start = %obj.getMuzzlePoint(0);
        %aimVec = %obj.getMuzzleVector(0);
	%targets = 
        $TypeMasks::PlayerObjectType | 
        $TypeMasks::StaticObjectType |   
        $TypeMasks::TerrainObjectType |    
        $TypeMasks::VehicleObjectType |    
        $TypeMasks::FXBrickObjectType;
	%damageType = $DamageType::superBoomstick;
    
    for(%i=0;%i<100;%i++)
      {
            %spread = 0.018;
            
            %vector = VectorScale(%aimVec, 100);
            %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
            %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
            %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
            %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
            %shotVec = vectorNormalize(MatrixMulVector(%mat, %vector));
         
         %range = 25*getWord(%obj.getScale(),2);
         
         %end = vectorAdd(%start,vectorScale(%shotVec,%range));
         %pos = %end;
        
         %ray = ContainerRayCast(%start, %end, %targets, %obj);
         %col = getWord(%ray,0);
         if(isObject(%col) && miniGameCanDamage(%obj,%col))
         {
            %colType = %col.getType();
            %pos = posFromRaycast(%ray);
            %normal = normalFromRaycast(%ray);
            %end = %pos;
            
             %distMult = 1;

	if((%col.getType() & $TypeMasks::PlayerObjectType) || (%col.getType() & $TypeMasks::VehicleObjectType))
	{
        //announce("fu");
		if(%col.boomHitAlready != 1)
		{
		//announce(vectorDist(%obj.getTransform(),%col.getTransform()) SPC %col.getClassname());
		//announce(%col.ea);
		%col.boomHitAlready = 1;
		%col.schedule(100,boomHitAlready);
		%distMult = vectorDist(%obj.getTransform(),%col.getTransform());
		%velVec = getWords(%shotvec,0,1) SPC "0.4";
		

		%directDamage = -5.6*%distMult + 130;
		if(%directDamage >= 75)
			%directDamage = 75;
		if(%directDamage <= 20)
			%directDamage = 20;

		%col.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%velvec,0.3*%directDamage)));
		
	//announce(%damageType);
   
  %col.damage(%obj, %pos, %directDamage, %damageType);
		}
	}
            
            //%this.onHitObject(%obj, %slot, %col, %pos, %normal, %shotVec, %crit);
         }
      }
}

function ShapeBase::boomHitAlready(%this)
{
	%this.boomHitAlready = 0;
}
